// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from system_modes_msgs:srv/GetMode.idl
// generated code does not contain a copyright notice
#include "system_modes_msgs/srv/detail/get_mode__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

bool
system_modes_msgs__srv__GetMode_Request__init(system_modes_msgs__srv__GetMode_Request * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
system_modes_msgs__srv__GetMode_Request__fini(system_modes_msgs__srv__GetMode_Request * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

system_modes_msgs__srv__GetMode_Request *
system_modes_msgs__srv__GetMode_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  system_modes_msgs__srv__GetMode_Request * msg = (system_modes_msgs__srv__GetMode_Request *)allocator.allocate(sizeof(system_modes_msgs__srv__GetMode_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(system_modes_msgs__srv__GetMode_Request));
  bool success = system_modes_msgs__srv__GetMode_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
system_modes_msgs__srv__GetMode_Request__destroy(system_modes_msgs__srv__GetMode_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    system_modes_msgs__srv__GetMode_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
system_modes_msgs__srv__GetMode_Request__Sequence__init(system_modes_msgs__srv__GetMode_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  system_modes_msgs__srv__GetMode_Request * data = NULL;

  if (size) {
    data = (system_modes_msgs__srv__GetMode_Request *)allocator.zero_allocate(size, sizeof(system_modes_msgs__srv__GetMode_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = system_modes_msgs__srv__GetMode_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        system_modes_msgs__srv__GetMode_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
system_modes_msgs__srv__GetMode_Request__Sequence__fini(system_modes_msgs__srv__GetMode_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      system_modes_msgs__srv__GetMode_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

system_modes_msgs__srv__GetMode_Request__Sequence *
system_modes_msgs__srv__GetMode_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  system_modes_msgs__srv__GetMode_Request__Sequence * array = (system_modes_msgs__srv__GetMode_Request__Sequence *)allocator.allocate(sizeof(system_modes_msgs__srv__GetMode_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = system_modes_msgs__srv__GetMode_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
system_modes_msgs__srv__GetMode_Request__Sequence__destroy(system_modes_msgs__srv__GetMode_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    system_modes_msgs__srv__GetMode_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}


// Include directives for member types
// Member `current_mode`
#include "rosidl_runtime_c/string_functions.h"

bool
system_modes_msgs__srv__GetMode_Response__init(system_modes_msgs__srv__GetMode_Response * msg)
{
  if (!msg) {
    return false;
  }
  // current_mode
  if (!rosidl_runtime_c__String__init(&msg->current_mode)) {
    system_modes_msgs__srv__GetMode_Response__fini(msg);
    return false;
  }
  return true;
}

void
system_modes_msgs__srv__GetMode_Response__fini(system_modes_msgs__srv__GetMode_Response * msg)
{
  if (!msg) {
    return;
  }
  // current_mode
  rosidl_runtime_c__String__fini(&msg->current_mode);
}

system_modes_msgs__srv__GetMode_Response *
system_modes_msgs__srv__GetMode_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  system_modes_msgs__srv__GetMode_Response * msg = (system_modes_msgs__srv__GetMode_Response *)allocator.allocate(sizeof(system_modes_msgs__srv__GetMode_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(system_modes_msgs__srv__GetMode_Response));
  bool success = system_modes_msgs__srv__GetMode_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
system_modes_msgs__srv__GetMode_Response__destroy(system_modes_msgs__srv__GetMode_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    system_modes_msgs__srv__GetMode_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
system_modes_msgs__srv__GetMode_Response__Sequence__init(system_modes_msgs__srv__GetMode_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  system_modes_msgs__srv__GetMode_Response * data = NULL;

  if (size) {
    data = (system_modes_msgs__srv__GetMode_Response *)allocator.zero_allocate(size, sizeof(system_modes_msgs__srv__GetMode_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = system_modes_msgs__srv__GetMode_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        system_modes_msgs__srv__GetMode_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
system_modes_msgs__srv__GetMode_Response__Sequence__fini(system_modes_msgs__srv__GetMode_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      system_modes_msgs__srv__GetMode_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

system_modes_msgs__srv__GetMode_Response__Sequence *
system_modes_msgs__srv__GetMode_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  system_modes_msgs__srv__GetMode_Response__Sequence * array = (system_modes_msgs__srv__GetMode_Response__Sequence *)allocator.allocate(sizeof(system_modes_msgs__srv__GetMode_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = system_modes_msgs__srv__GetMode_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
system_modes_msgs__srv__GetMode_Response__Sequence__destroy(system_modes_msgs__srv__GetMode_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    system_modes_msgs__srv__GetMode_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}
